//+------------------------------------------------------------------+
//|                                                          OCC.mq4 |
//|                            Copyright  2008, Indarisa Enterprise |
//|                                            http://www.salmir.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Indarisa Enterprise"
#property link      "http://www.salmir.com"

//---- indicator parameters
extern int ExtDepth=12;
extern int ExtDeviation=5;
extern int ExtBackstep=3;
//---- indicator buffers
double ZigzagBuffer[];
double HighMapBuffer[];
double LowMapBuffer[];
int level=3; // recounting's depth 
bool downloadhistory=false;
extern bool Corner_of_Chart_RIGHT_TOP = true;

   int m, counted_bars;
   int limit,counterZ,whatlookfor;
   int shift,back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

double Hival, Loval;
string strHival, strLoval;
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
//---- indicator buffers mapping
   SetIndexBuffer(0,ZigzagBuffer);
   SetIndexBuffer(1,HighMapBuffer);
   SetIndexBuffer(2,LowMapBuffer);
   SetIndexEmptyValue(0,0.0);

//---- indicator short name
   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


void Display()
{
   ObjectCreate("lblObj1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("lblObj1","Current High : "+strHival+"", 11, "Comic Sans MS",  Black);
   ObjectSet("lblObj1", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("lblObj1", OBJPROP_XDISTANCE, 50);
   ObjectSet("lblObj1", OBJPROP_YDISTANCE, 210);
   
   ObjectCreate("lblObj2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("lblObj2","Current Low : "+strLoval+"", 11, "Comic Sans MS",  Black);
   ObjectSet("lblObj2", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("lblObj2", OBJPROP_XDISTANCE, 50);
   ObjectSet("lblObj2", OBJPROP_YDISTANCE, 225);

   ObjectCreate("lblObj3", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("lblObj3","Low position : "+lastlowpos+"", 11, "Comic Sans MS",  Black);
   ObjectSet("lblObj3", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("lblObj3", OBJPROP_XDISTANCE, 50);
   ObjectSet("lblObj3", OBJPROP_YDISTANCE, 240);
   
   ObjectCreate("lblObj4", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("lblObj4","High position : "+lasthighpos+"", 11, "Comic Sans MS",  Black);
   ObjectSet("lblObj4", OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet("lblObj4", OBJPROP_XDISTANCE, 50);
   ObjectSet("lblObj4", OBJPROP_YDISTANCE, 255);   

 
}


int start()
  {
   //counted_bars = IndicatorCounted();

   if (counted_bars==0 && downloadhistory) // history was downloaded
     {
      ArrayInitialize(ZigzagBuffer,0.0);
      ArrayInitialize(HighMapBuffer,0.0);
      ArrayInitialize(LowMapBuffer,0.0);
     }
   if (counted_bars==0) 
     {
      limit=Bars-ExtDepth;
      downloadhistory=true;
     }
   if (counted_bars>0) 
     {
      while (counterZ<level && m<100)
        {
         res=ZigzagBuffer[m];
         if (res!=0) counterZ++;
         m++;
        }
      m--;
      limit=m;
      if (LowMapBuffer[m]!=0) 
        {
         curlow=LowMapBuffer[m];
         whatlookfor=1;
        }
      else
        {
         curhigh=HighMapBuffer[m];
         whatlookfor=-1;
        }
      for (m=limit-1;m>=0;m--)  
        {
         ZigzagBuffer[m]=0.0;  
         LowMapBuffer[m]=0.0;
         HighMapBuffer[m]=0.0;
        }
     }
      
   for(shift=limit; shift>=0; shift--)
     {
      val=Low[iLowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=LowMapBuffer[shift+back];
               if((res!=0)&&(res>val)) LowMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      if (Low[shift]==val) LowMapBuffer[shift]=val; else LowMapBuffer[shift]=0.0;
      //--- high
      val=High[iHighest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=HighMapBuffer[shift+back];
               if((res!=0)&&(res<val)) HighMapBuffer[shift+back]=0.0; 
              } 
           }
        }
      if (High[shift]==val) HighMapBuffer[shift]=val; else HighMapBuffer[shift]=0.0;
     }

   // final cutting 
   if (whatlookfor==0)
     {
      lastlow=0;
      lasthigh=0;  
     }
   else
     {
      lastlow=curlow;
      lasthigh=curhigh;
     }
   for (shift=limit;shift>=0;shift--)
     {
      res=0.0;
      switch(whatlookfor)
        {
         case 0: // look for peak or lawn 
            if (lastlow==0 && lasthigh==0)
              {
               if (HighMapBuffer[shift]!=0)
                 {
                  lasthigh=High[shift];
                  lasthighpos=shift;
                  whatlookfor=-1;
                  ZigzagBuffer[shift]=lasthigh;
                  res=1;
                 }
               if (LowMapBuffer[shift]!=0)
                 {
                  lastlow=Low[shift];
                  lastlowpos=shift;
                  whatlookfor=1;
                  ZigzagBuffer[shift]=lastlow;
                  res=1;
                 }
              }
             break;  
         case 1: // look for peak
            if (LowMapBuffer[shift]!=0.0 && LowMapBuffer[shift]<lastlow && HighMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lastlowpos]=0.0;
               lastlowpos=shift;
               lastlow=LowMapBuffer[shift];
               ZigzagBuffer[shift]=lastlow;
               res=1;
              }
            if (HighMapBuffer[shift]!=0.0 && LowMapBuffer[shift]==0.0)
              {
               lasthigh=HighMapBuffer[shift];
               lasthighpos=shift;
               ZigzagBuffer[shift]=lasthigh;
               whatlookfor=-1;
               res=1;
              }   
            break;               
         case -1: // look for lawn
            if (HighMapBuffer[shift]!=0.0 && HighMapBuffer[shift]>lasthigh && LowMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lasthighpos]=0.0;
               lasthighpos=shift;
               lasthigh=HighMapBuffer[shift];
               ZigzagBuffer[shift]=lasthigh;
              }
            if (LowMapBuffer[shift]!=0.0 && HighMapBuffer[shift]==0.0)
              {
               lastlow=LowMapBuffer[shift];
               lastlowpos=shift;
               ZigzagBuffer[shift]=lastlow;
               whatlookfor=1;
              }   
            break;               
         default: return; 
        }
     }
   Hival = iHigh(NULL,0,lasthighpos);
   Loval = iLow(NULL,0,lastlowpos);
   strHival = DoubleToStr(Hival,Digits);
   strLoval = DoubleToStr(Loval,Digits);    
   downloadhistory=false;
   Display();
   
   return(0);
  }
//+------------------------------------------------------------------+